local stroke_w = 10

Box = Core.class(Sprite)

function Box:init(w, h)
	self.w = w
	self.h = h
	self._init_size = {self.w, self.h}
	self._body_pos = {0, 0}
	self._phys_sett = {0,0,0}
	self.shape = createFilledRect(self.w, self.h, 0xffffff, {0.5, 0.5})
	self:addChild(self.shape)
end
function Box:createBody(world, type, name, d, f, r)
	d = d or 0 self._phys_sett[1] = d
	f = f or 1 self._phys_sett[2] = f
	r = r or 0 self._phys_sett[3] = r
	name = name or "box"
	self.body = world:createBody({type=type, fixedRotation = false, allowSleep = false, bullet = true})
	local box = b2.PolygonShape.new()
	box:setAsBox(self.w/2, self.h/2)
	self._fixture = self.body:createFixture({shape = box, friction = f, density = d, restitution = r})
	self.body:setPosition(self:getX(), self:getY())
	self._body_pos[1] = self:getX()
	self._body_pos[2] = self:getY()
	self.body.name = name
end
function Box:reColor(t) if t then self:setColorTransform(t[1],t[2],t[3]) else self:setColorTransform(math.random(),math.random(),math.random()) end end
function Box:setSize(w, h) 
	self.w = w 
	self.h = h
	self.shape:setScale( self.w / self._init_size[1], self.h / self._init_size[2] )
	self.body:destroyFixture(self._fixture)
	local box = b2.PolygonShape.new()
	box:setAsBox(self.w/2, self.h/2)
	self._fixture = self.body:createFixture({shape = box, friction = self._phys_sett[2], density = self._phys_sett[1], restitution = self._phys_sett[3]})
end
--
function Box:setX2(x)
	self:setX(x)
	self._body_pos[1] = x
	self.body:setPosition(x, self._body_pos[2])
end
--
function Box:setY2(y)
	self:setY(y)
	self._body_pos[2] = y
	self.body:setPosition(self._body_pos[1], y)
end
--
function Box:setPosition2(x,y)
	self:setPosition(x, y)
	self._body_pos[1] = x
	self._body_pos[2] = y
	self.body:setPosition(x, y)
end
--
function Box:getBody() return self.body end
