local random = math.random
local c = {1,2,3,4,5,6,7,8,9,"a","b","c","d","e","f"}

function randomColor(start, end_) if end_ then return random(start, end_) else return random(start) end end
function rndColor() return "0x"..c[random(#c)]..c[random(#c)]..c[random(#c)]..c[random(#c)]..c[random(#c)]..c[random(#c)] end

function createFilledRect(w, h, color, anchor)
	anchor = anchor or {0, 0}
	local s = Shape.new()
	s:setFillStyle(Shape.SOLID, color)
	local cx = (anchor[1] * w)
	local cy = (anchor[2] * h)
	s:beginPath()
	s:moveTo(-cx, -cy)
	s:lineTo(-cx + w, -cy)
	s:lineTo(-cx + w, -cy + h)
	s:lineTo(-cx, -cy + h)
	s:lineTo(-cx, -cy)
	s:endPath()
	return s
end
--
function createStrokeRect(w, h, color, anchor)
	anchor = anchor or {0, 0}
	local s = Shape.new()
	s:setFillStyle(Shape.NONE)
	s:setLineStyle(4, color)
	local cx = (anchor[1] * w)
	local cy = (anchor[2] * h)
	s:beginPath()
	s:moveTo(-cx, -cy)
	s:lineTo(-cx + w, -cy)
	s:lineTo(-cx + w, -cy + h)
	s:lineTo(-cx, -cy + h)
	s:lineTo(-cx, -cy)
	s:endPath()
	return s
end
--
function createRect(w, h, anchor, fillStyle, lineStyle)
	anchor = anchor or {0, 0}
	fillStyle = fillStyle or {Shape.SOLID, 0xffffff, 1} fillStyle[1] = fillStyle[1] or Shape.SOLID fillStyle[2] = fillStyle[2] or 0xffffff fillStyle[3] = fillStyle[3] or 1
	lineStyle = lineStyle or {2, 0x000000, 1} lineStyle[1] = lineStyle[1] or 2 lineStyle[2] = lineStyle[2] or 0xffffff lineStyle[3] = lineStyle[3] or 1
	
	local s = Shape.new()
	s:setFillStyle(unpack(fillStyle))
	s:setLineStyle(unpack(lineStyle))
	local cx = (anchor[1] * w)
	local cy = (anchor[2] * h)
	s:beginPath()
	s:moveTo(-cx, -cy)
	s:lineTo(-cx + w, -cy)
	s:lineTo(-cx + w, -cy + h)
	s:lineTo(-cx, -cy + h)
	s:lineTo(-cx, -cy)
	s:endPath()
	return s
end
--
function createGradientRect(w, h, c1, c2, a1, a2)
	a1 = a1 or 1 a2 = a2 or 1
	local mesh = Mesh.new()
	mesh:setVertexArray(0,0,w,0,w,h,0,h)
	mesh:setIndexArray(1,2,3,1,3,4)
	mesh:setColorArray(c1, a1, c1, a1, c2, a2, c2, a2)
	return mesh
end

function recolorGradient(mesh, c1, c2, a1, a2)
	a1 = a1 or 1 a2 = a2 or 1
	mesh:setColorArray(c1, a1, c1, a1, c2, a2, c2, a2)
end